function [plantmass,soilchem_pred,residchem,residdepth,residgroup] = mk_verhib_output(nrcomp,nrlayers,nrplants,nrgroups,X,y,par,leafrootratio)

% totale lengte van y is:
%   nrcomp*nrlayers + nrplants*(nrlayers-1) + nrgroups*nrlayers
%

residual = y - X*par;

if length(par)==nrplants*nrlayers   % only leaves were considered - no roots

    totmass = par + par./repmat(leafrootratio(:),nrlayers,1);
    plantmass = reshape( totmass, nrplants, nrlayers );

    soilchem_pred = reshape(y(1:nrcomp*nrlayers),nrcomp,nrlayers);

    residchem = reshape(residual(1:nrcomp*nrlayers),nrcomp,nrlayers);

    brk = nrcomp*nrlayers;

    residdepth = reshape( residual( brk + 1 : brk + nrplants*(nrlayers-1) ), nrplants, nrlayers-1);

    brk = nrcomp*nrlayers + nrplants*(nrlayers-1);

    residgroup = reshape( residual( brk + 1 : brk + nrgroups*nrlayers ), nrgroups, nrlayers);

else  % both leaves and roots were considered.


    % reshape the parameter output and calculate the relative contribution
    % of each plant to the total
    plantmass = reshape( par( 1 : nrplants*nrlayers ), nrplants, nrlayers ) + ...
        reshape( par( nrplants*nrlayers+1 : 2*nrplants*nrlayers ), nrplants, nrlayers ) ;
    % plantmass_relative = plantmass ./ repmat( sum(plantmass) ,nrplants,1 );

    % should be the same
    % rootpar = reshape( par(nrplants*nrlayers+1:end), nrplants, nrlayers );
    % rootpar_relative = rootpar ./ repmat( sum(rootpar) ,nrplants,1 );

    % reshape the predicted biomarker concentration to the right format:
    % after 'reshape' each row is one component, each column is one layer,
    % this is transposed.
    % the same for the residuals and regularized values
    soilchem_pred = reshape(y(1:nrcomp*nrlayers),nrcomp,nrlayers);

    residchem = reshape(residual(1:nrcomp*nrlayers),nrcomp,nrlayers);

    brk = nrcomp*nrlayers;

    residdepth = reshape( residual( brk + 1 : brk + nrplants*nrlayers ), nrplants, nrlayers);

    brk = nrcomp*nrlayers + nrplants*nrlayers;

    residgroup = reshape( residual( brk + 1 : brk + nrgroups*nrlayers ), nrgroups, nrlayers);

end
