function [soilchem,leafchem,rootchem,leafdepth,rootdepth,plantgroups,useleaf,useroot,leafrootratio,yearperlayer,nrcomp,nrlayers,nrplants,nrgroups,depthlbl_num,species,chemlbl] = read_verhib_xls(inputxls)

    %% load data from 'inputxls'

    [dat,lbl] = xlsread( inputxls, 'includechem' );
    % endcol = size(dat,2);
    inchem = logical( [0 dat] );
    chemlbl = lbl(1,inchem);    

    [dat,lbl] = xlsread( inputxls, 'plantgroups' );
    useleaf = logical( dat(:,6) );
    useroot = logical( dat(:,7) );
    inplant = useleaf | useroot;
    useleaf = logical( dat(inplant,6) )';
    useroot = logical( dat(inplant,7) )';
    leafrootratio = dat( inplant, end )';

    plantgroups = dat( inplant, 2:end-3 )';
    inplantlbl = [false; inplant];

    family = lbl( inplantlbl, 1 );
    genus = lbl( inplantlbl, 2);
    species =  lbl( inplantlbl, 3 );

    [dat,lbl] = xlsread( inputxls, 'depthdur' );
    yearperlayer = dat(:,2);

    [dat,lbl] = xlsread( inputxls, 'soilchem' );
    soilchem = dat( :, inchem )';
    depthlbl_num = dat(:,1);

    [dat,lbl] = xlsread( inputxls, 'leafchem' );
    leafchem = dat( inplant, inchem )';

    [dat,lbl] = xlsread( inputxls, 'rootchem' );
    rootchem = dat( inplant, inchem )';

    [dat,lbl] = xlsread( inputxls, 'leafdepth' );
    leafdepth = dat( inplant, 2:end )';
    depthlbl_str = lbl( 1, 5:end );

    [dat,lbl] = xlsread( inputxls, 'rootdepth' );
    rootdepth = dat( inplant, 2:end )';

    % rootchem = [];
    % rootdepth =[];

    % determine the dimension of the problem
    [nrcomp,nrlayers] = size(soilchem);
    nrplants = size(leafchem,2);

    % remove plantgroups without plants
    plantsingroup = sum(plantgroups,2)>0;
    plantgroups = plantgroups(plantsingroup,:);
    nrgroups = size( plantgroups, 1 );
